/// <reference types="audioworklet" />
import { SyncedSet } from 'synced-set';
import type { SchedulerEvent, SchedulerEventGroup } from './scheduler-event';
import type { SchedulerNode, SchedulerSyncedSetPayload } from './scheduler-node';
export declare class SchedulerProcessor extends AudioWorkletProcessor {
    blockSize: number;
    private quantumDurationTime;
    private bpm;
    coeff: number;
    playbackStartTime: number;
    adjustedStartTime: number;
    offsetStartTime: number;
    internalTime: number;
    diffTime: number;
    running: boolean;
    eventGroups: SyncedSet<SchedulerEventGroup, SchedulerSyncedSetPayload>;
    suspended: Set<string>;
    turns: Map<SchedulerEventGroup, Map<number, Set<SchedulerEvent>>>;
    node: SchedulerNode;
    constructor();
    start(playbackStartTime?: number, offsetStartTime?: number): Promise<number>;
    stop(): void;
    seek(seekTime: number): Promise<number>;
    setBpm(bpm: number): Promise<number>;
    suspendTarget(targetId: string): void;
    resumeTarget(targetId: string): void;
    clearEventGroup(eventGroupId: string): void;
    waitingEvents: Set<string>;
    receiveEvents(eventGroupId: string, turn: number, turns: Set<SchedulerEvent>[], clear?: boolean): void;
    process(): boolean;
    requestNextEvents(eventGroupId: string, turn: number, total: number): void;
}
